#undef NO_MAILACCT

#ifndef MAIN
# include "sendmail.h"
#else
# include <strings.h>
# include <stdio.h>
#endif

#include <fnmatch.h>

#ifndef NO_HONOR_RELAY

#define HOSTFILE "/etc/mail/sendmail.rj"
#define MAILDROP "/var/log/maildrop"

static char *get_dst_addr(addr)
char *addr;
{
  char buf[4906];
  char *p = 0, *bp = buf;

  strncpy(buf, addr, 4096);
  if (p = strrchr(buf, ':')) return get_dst_addr(++p);
  else if (p = strrchr(buf, '@')) *p++ = 0;
  else if (p = strchr(buf, '!')) { *p++ = 0; bp = p; p = buf; }
  else if (p = strrchr(buf, '%')) *p++ = 0;
  else return NULL;
  if (strpbrk(bp, "!%@")) return get_dst_addr(bp);
  return strdup(p);
}

/*
 * if (smtp_verify(CurHostName, a->q_user))
 *   break;
 */

int smtp_verify(src, user)
char *src, *user;
{
  char *mxrr[MAXMXHOSTS] = { "RELAY" };
  int rcode, nmx;
  int c;
  char buf[4096];
  FILE *f;
  char *p;
  char *dst;
  int mxed = 0;

  if (strcmp(src, "localhost"))
    for (p=src; *p; p++) *p = tolower(*p);

  p = get_dst_addr(user);
  if (!p) return 0;		/* Local user, no domain part */

  if (!(f = fopen(HOSTFILE, "r"))) {
    free(p);
    return 0;			/* Nothing to do here */
  }

  for (dst = p; *p; p++) *p = tolower(*p);
  if ((p = strstr(dst, ".uucp")) && (strlen(p) == 5)) *p = 0;

  while (fgets(buf, 4096, f)) {
    char *from, *to;
    from = strtok(buf, " \t\n");
    if (!from || !*from || (*from == '#')) continue;
    to = strtok(NULL, " \t\n");
    if (!fnmatch(from, src, 0)) {
      if (!strcmp(to, "*")) {
	fclose(f);		/* Thanks to pasa@queen.ru: */
	free(dst);		/* src allowed to send to everything (*) */
	return 0;		/* we're don't ask about mx, permit it */
      }
    } else continue;
    if (!mxed) {		/* Do it only at first time */
      if (strchr(dst, '.')) {
	/* domainized address, try to get MX'rr from BIND */
	nmx = getmxrr(dst, mxrr, FALSE, &rcode);
	if (nmx < 0) {
	  message("550 destination address `%s' has no MX", user);
	  fclose(f);
	  free(dst);
	  return 1;		/* No MX - fuck it out! */
	}
	for (p=mxrr[0]; *p; p++) *p = tolower(*p);
      } else mxrr[0] = dst;	/* dst is a uucp name, already lowered */
      mxed = 1;			/* mark we're already asked about MX'rr */
    }
    if (!fnmatch(to, mxrr[0], 0)) {
      fclose(f);
      free(dst);
      return 0;			/* dst permited by current record*/
    }
    /* don't match, continuing... */
  }
  fclose(f);
  /* We're does not found any match. Deny relaying. */
  message("550 %s -> %s: Relaying denied", src, user);

  if (f = fopen(MAILDROP, "a")) {
    fprintf(f, "%s\t%s\t(%s -> %s)\n",
	    src, user, dst, mxrr[0]);
    fclose(f);
  }
  free(dst);
  return 1;			/* Finger outside for other fun! */
}
#endif /* NO_HONOR_RELAY */

#ifndef NO_MAILACCT
#ifndef MAIN
# define ACCTFILE "/var/log/mailacct"
#else
# define ACCTFILE "./mailacct"
#endif

static char __b_buff[4096];

static void _b_cat(src)
char *src;
{
  char *p;

  if (p = strchr(src, '<')) src=++p;
  if (p = strrchr(src, '>')) *p = 0;
  for (p=src; *p; p++); (*--p == '.') && (*p = 0);

  if ((p=strstr(src, ".uucp")) && (strlen(p)==5)) *p = 0;
  if (!strlen(src)) return;
  strcat(__b_buff, "!");
  strcat(__b_buff, src);
}

static void _bangonify(str)
char *str;
{
  char buf[4096];
  char *p, *bp = buf;

  strcpy(buf, str);
  for (p=buf; *p; p++) *p = tolower(*p);

  if (p = strrchr(bp, ':')) {
    *p++ = 0;
    _bangonify(bp);
    _bangonify(p);
    return;
  }
  if (p = strchr(bp, ',')) {
    *p++ = 0;
    _bangonify(bp);
    _bangonify(p);
    return;
  }
  if (p = strrchr(bp, '@')) {
    *p++ = 0;
    _b_cat(p);
    _bangonify(bp);
    return;
  }
  if (p = strchr(bp, '!')) {
    *p++ = 0;
    _b_cat(bp);
    _bangonify(p);
    return;
  }
  if (p = strrchr(bp, '%')) {
    *p++ = 0;
    _b_cat(p);
    _bangonify(bp);
    return;
  }
  _b_cat(bp);
  return;
}

char *bangonify(str)
char *str;
{
  *__b_buff = 0;
  _bangonify(str);
  return &__b_buff[1];
}

#define LOCAL "LOCAL"
#define PROGRAM "PROGRAMM"
#define MFILE "FILE"


#ifndef MAIN
#define acct(c) fprintf(acf, " $%c=%s", c, macvalue(c, e))

void mailacct(e, to, h)
ENVELOPE *e;
ADDRESS *to;
char *h;
{
  FILE *acf;
  time_t t = time(NULL);
  struct tm *tm = localtime(&t);
  char *fromh, *toh;
  char *fromu, *tou;
  char *p;

  if ((acf = fopen(ACCTFILE, "a")) == NULL) return;
/*
  fprintf(acf, "#");
  acct('f');
  acct('g');
  acct('h');
  acct('s');
  acct('u');
  acct('w');
  fprintf(acf, "\n");
  
  fprintf(acf, "#e_sender=%s e_size=%d, q_user=%s q_host=%s curhost=%s\n\n",
	  e->e_sender, e->e_msgsize, to->q_user, to->q_host, h);
*/
  (fromh = macvalue('s', e)) || (fromh = LOCAL);
  toh = h ? h : *to->q_host ? to->q_host : LOCAL;
  (toh[strlen(toh)-1] == '.') && (toh[strlen(toh)-1] = 0);
  fromu = strdup(bangonify(macvalue('g', e)));
  tou = to->q_user;
  if (*tou == '/') tou = MFILE;
  else if (*tou == '|') tou = PROGRAM;
  else tou = bangonify(to->q_user);

  fprintf(acf, "%s!%s\t%s!%s\t%d\t%02d:%02d:%02d %02d.%02d.%d\n",
	  fromh, *fromu ? fromu : "MAILER-DAEMON", toh, tou, e->e_msgsize+214,
	  tm->tm_hour,tm->tm_min,tm->tm_sec,
	  tm->tm_mday,tm->tm_mon+1,tm->tm_year + 1900);
  free(fromu);
  fclose(acf);
}
#endif
#endif /* NO_MAILACCT */

#ifdef MAIN
int main() {

  char arr[256];
  
  while (fgets(arr, 256, stdin)) {
    char *p = strchr(arr, '\n');
    if (p) *p = 0;

    printf("%s\n%s\n\n", arr, bangonify(arr));
  }

  return 0;
}
#endif

#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <errno.h>

#define MAX_XLA 256
#define XLA_FILE "/var/run/sendmail.xl"

/* Set one slot in XLA flag file */
void setxla() {

  int xf, cnt;
  struct flock fc;

  xf = open(XLA_FILE, O_RDWR|O_CREAT, 0600);
  if (xf < 0) return;

  for (cnt=0; cnt<MAX_XLA; cnt++) {
    fc.l_start = cnt;
    fc.l_len = 1;
    fc.l_type = F_WRLCK;
    fc.l_whence = SEEK_SET;

    if (fcntl(xf, F_SETLK, &fc) < 0) continue;
    /* Improtant!!! Do not close() xf file!!! */
    return;
  }
  close(xf);
  /* More than MAX_XLA locks are set; nothing to do */
}

int getxla() {

  int xf, cnt, lcnt;
  struct flock fc;

  xf = open(XLA_FILE, O_RDWR, 0);
  if (xf < 0) return 0;		/* No XLA file, LA=0 */
  for (lcnt=cnt=0; cnt<MAX_XLA; cnt++) {
    fc.l_start = cnt;
    fc.l_len = 1;
    fc.l_whence = SEEK_SET;
    fc.l_type = F_UNLCK;
    fcntl(xf, F_GETLK, &fc);
    if (fc.l_type != F_UNLCK) lcnt++;
  }
  close(xf);
  return lcnt;
}
